/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.gematik.ti.vauchannel.protocol.sign;


import de.gematik.ti.vauchannel.protocol.helpers.Base64;
import de.gematik.ti.vauchannel.protocol.helpers.Identity;
import de.gematik.ti.vauchannel.protocol.helpers.VAUProtocolCryptoImpl;
import org.junit.*;

import java.io.File;
import java.io.FileOutputStream;
import java.security.KeyPair;

import static org.junit.Assert.assertTrue;

/**
 *
 * @author matth
 */
public class SignerTest {
    
    public SignerTest() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }


    /**
     * Test of signECDSA method, of class Signer.
     */
    @Test
    public void testSignVerifyECDSA() throws Exception {
        Identity identity = Identity.generateSelfSigned_ECC();
        VAUProtocolCryptoImpl crypto = new VAUProtocolCryptoImpl(true, identity);
        byte[] message = "My message".getBytes();
        byte[] result = crypto.signECDSA(message);
        System.out.println("ECDSA:");
        System.out.println(Base64.encode2String(result));
        boolean ok = crypto.verify(message, result, identity.certificate.getPublicKey());
        assertTrue(ok);
    }
    

    @Test
    public void testSignVerifyRSASSA_PSS() throws Exception {
        Identity identity = Identity.generateSelfSigned_RSA();
        VAUProtocolCryptoImpl crypto = new VAUProtocolCryptoImpl(false, identity);
        byte[] message = "My message".getBytes();
        byte[] result = crypto.signRSASSA_PSS(message );
        System.out.println("RSASSA_PSS:");
        System.out.println(Base64.encode2String(result));
        boolean ok =    crypto.verify(message, result, identity.certificate.getPublicKey());
        assertTrue(ok);
    }


    
}
